#! /usr/bin/perl
# mlnew.cgi : create new ML for PPML
# Copyright(C) 2001 by Yuh.N
# $Id: mlnew.cgi,v 1.2 2001/02/02 15:45:03 yuh Exp $
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
umask(0077);
use CGI;

require "mllib.pl";

$PIDFILE = "$ML_SETTING_ROOT/mlnew.pid";

$q = new CGI;
print $q->header(-expires=>now, -title=>'MLjoin');
print $q->start_html(-bgcolor=>'#ffffff');
print "<form action=$ENV{'SCRIPT_NAME'} method=POST>\n";
print '<h1>᡼󥰥ꥹȿ</h1>',"\n";

if ($q->param('SUBMIT') eq 'Accept') {

    $ml = $q->param('MLname');
    # tolower
    $ml =~ y/A-Z/a-z/;
    # do not use 
    if ($ml =~ /([^\@]+)@.*/) {
	$ml = $1;
    }
    if ($ml =~ /[\.\/\:]/) {
	print "᡼󥰥ꥹ̾˻Ȥʤʸޤ<br>\n";
	last;
    }

    $pass = $q->param('MLpass');
    $admin = $q->param('MLadmin');

    if ($ml eq "") {
	print "᡼󥰥ꥹ̾ϤƤޤ<br>\n";
	last;
    }

    if ($pass eq "") {
	$pass = $ml;
    }

    if ($admin eq "") {
	$admin = 'root';
    }

    if ($admin eq $ml) {
	$admin = 'root';
    }

    #
    # read aliases
    #
    open(A, $ALIASES) || die $!;

    @lst = ();
    %ali = ();
    $prev = "";
    while (<A>) {
	next if (/^\#/);
	$line = $_;
	if (/^[\t: ]+(.*)/) {
	    $prev .= $1;
	}
	else {
	    ($key, @wk) = split(/[:, \t\r\n]+/, $prev);
	    push(@lst, $key);
	    $ali{$key} .= join(',', @wk);
	    $prev = $line;
	}
    }
    ($key, @wk) = split(/[:, \t\r\n]+/, $prev);
    push(@lst, $key);
    $ali{$key} .= join(',', @wk);
    close(A);


    if (defined($ali{$ml})) {
	print "᡼󥰥ꥹ $ml ϺǤޤʤǤƱ̾Υ᡼󥰥ꥹȤꥢޤ<br>\n";
	last;
    }

    if (getpwnam($ml) ne undef) {
	print "᡼󥰥ꥹ $ml ϺǤޤʤǤƱ̾Υ桼ޤ<br>\n";
	last;
    }

    #
    # update /etc/aliases
    #

    lock_on($PIDFILE);
    open(A, ">>$ALIASES") || die $!;
    printf(A "%s:\t\t:include:%s/%s/include\n", $ml, $ML_SETTING_ROOT, $ml);
    printf(A "%s-request:\t%s\n", $ml, $admin);
    close(A);
    lock_off($PIDFILE);
#    system("newaliases");

    #
    # post 'generate' command to ML controller
    #

    if ($AUTOGENERATE == 1) {

	$tmpfile = "/tmp/mlnew.$$";
	open(M, ">$tmpfile");
	print(M "generate $ml $pass\n");
	close(M);
	system("Mail -s generate $ML_CONTROL < $tmpfile");
	unlink($tmpfile);
    }
    else {
	print("sitedef.ph  AUTOGENERATE  1 ˥åȤƤޤ\n");
    }


    #
    # update 'mlinfo.ph'
    #

    $target = "$ML_SETTING_ROOT/mlinfo.ph";
    $tmpfile = "$ML_SETTING_ROOT/mlinfo.$$";
    if (-f $target) {
	open(SRC, $target);
	open(DST, ">$tmpfile") || die $!;
	while (<SRC>) {
	    print DST;
	    if (/-- automatically append from this line --/) {
		printf(DST "'%s'\t=> '%s',\n", $ml, $q->param('MLinfo'));
	    }
	}
	close(DST);
	close(SRC);

	system("mv -f $tmpfile $target");
    }

    print "᡼󥰥ꥹ $ml ޤ\n"

}
else {

    print << "EOT";
	<table>
	<tr>
	<td>᡼󥰥ꥹ̾</td>
	<td><input type=text name=MLname></td>
	</tr>
	<tr>
	<td>ԥ᡼륢ɥ쥹</td>
	<td><input type=text name=MLadmin></td>
	</tr>
	<tr>
	<td>ѥ</td>
	<td><input type=text name=MLpass></td>
	</tr>
EOT
    if (-f "$ML_SETTING_ROOT/mlinfo.ph") {
    print << "EOT";
	<tr>
	<td></td>
	<td><input type=text size=40 name=MLinfo></td>
	</tr>
EOT
}
    print << "EOT";
	</table>
EOT

    print "<input type=submit name=SUBMIT value=Accept>\n";
}

print "</form>\n";
print $q->end_html();

